unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, AdvUtil, Vcl.Grids, AdvObj, BaseGrid,
  AdvGrid;

type
  TForm1 = class(TForm)
    AdvStringGrid1: TAdvStringGrid;
    AdvStringGrid2: TAdvStringGrid;
    procedure AdvStringGrid1OleDropFile(Sender: TObject; ARow, ACol: Integer;
      FileName: string; var Allow: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure AdvStringGrid1OleDrop(Sender: TObject; ARow, ACol: Integer;
      data: string; var Allow: Boolean);
    procedure AdvStringGrid1OleDrag(Sender: TObject; ARow, ACol: Integer;
      data: string; var Allow: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
    fn: string;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.AdvStringGrid1OleDrag(Sender: TObject; ARow, ACol: Integer;
  data: string; var Allow: Boolean);
begin
  fn := '';

  allow :=  (Sender as TAdvStringgrid).HasFilePicture(ACol,ARow);
  if allow then
    fn := (Sender as TAdvStringGrid).GetFilePicture(ACol,ARow).Filename;
end;

procedure TForm1.AdvStringGrid1OleDrop(Sender: TObject; ARow, ACol: Integer;
  data: string; var Allow: Boolean);
var
  fp: TFilePicture;
begin
  if fn <> '' then
  begin
   fp := (Sender as TAdvstringgrid).GetFilePicture(ACol,ARow);
   if Assigned(fp) then
     fp.Filename := fn
   else
     (Sender as TAdvstringgrid).CreateFilePicture(ACol,ARow,false,StretchWithAspectRatio,0,haLeft,vaTop).Filename := fn;
  end;
end;

procedure TForm1.AdvStringGrid1OleDropFile(Sender: TObject; ARow, ACol: Integer;
  FileName: string; var Allow: Boolean);
var
  ext: string;
begin
  ext := Uppercase(ExtractFileExt(FileName));

  if (ext = '.JPEG') or (ext = '.JPG') then
    (Sender as TAdvstringgrid).CreateFilePicture(ACol,ARow,false,StretchWithAspectRatio,0,haLeft,vaTop).Filename := filename;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  advstringgrid1.DragDropSettings.OleDropTarget := true;
  advstringgrid1.DragDropSettings.OleDropSource := true;

  advstringgrid2.DragDropSettings.OleDropTarget := true;
  advstringgrid2.DragDropSettings.OleDropSource := true;

end;

end.
